---
title: WebGL2RenderingContext.copyTexSubImage3D()
slug: Web/API/WebGL2RenderingContext/copyTexSubImage3D
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGL2
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGL2RenderingContext.copyTexSubImage3D()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> copies pixels from the current {{domxref("WebGLFramebuffer")}} into an existing 3D texture sub-image.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.copyTexSubImage3D(<var>target</var>, <var>level</var>, <var>xoffset</var>, <var>yoffset</var>, <var>zoffset</var>, <var>x</var>, <var>y</var>, <var>width</var>, <var>height</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>target</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the binding point (target) of the active texture. Possible values:
 <ul>
  <li><code>gl.TEXTURE_3D</code>: A three-dimensional texture.</li>
  <li><code>gl.TEXTURE_2D_ARRAY</code>: A two-dimensional array texture.</li>
 </ul>
 </dd>
 <dt><code>level</code></dt>
 <dd>A {{domxref("GLint")}} specifying the level of detail. Level 0 is the base image level and level <em>n</em> is the <em>n</em>th mipmap reduction level.</dd>
 <dt><code>xoffset</code></dt>
 <dd>A {{domxref("GLint")}} specifying the x offset within the texture image.</dd>
 <dt><code>yoffset</code></dt>
 <dd>A {{domxref("GLint")}} specifying the y offset within the texture image.</dd>
 <dt><code>zoffset</code></dt>
 <dd>A {{domxref("GLint")}} specifying the z offset within the texture image.</dd>
 <dt><code>x</code></dt>
 <dd>A {{domxref("GLint")}} specifying the x coordinate of the lower left corner where to start copying.</dd>
 <dt><code>y</code></dt>
 <dd>A {{domxref("GLint")}} specifying the y coordinate of the lower left corner where to start copying.</dd>
 <dt><code>width</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the width of the texture.</dd>
 <dt><code>height</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the height of the texture.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">gl.copyTexSubImage3D(gl.TEXTURE_3D, 0, 0, 0, 0, 0, 0, 16, 16);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.6", "copyTexSubImage3D")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glCopyTexSubImage3D.xhtml", "glCopyTexSubImage3D")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGL2RenderingContext.copyTexSubImage3D")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.copyTexImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.texImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.texSubImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.compressedTexImage2D()")}}</li>
</ul>
